#!/usr/bin/perl -w
# Install script for Matt's cvsmail scripts
# Yes, doing this in Perl is overkill.  I don't feel like screwing with
# Bourne shell, and...  wait, why am I justifying myself to you?
# $Fuller: cvsmail/install.pl,v 1.1.1.1 2002/04/20 15:08:38 fullermd Exp $

use strict;

if(!$ARGV[0])
{
	print "Usage: $0 <location>\n";
	print "  Where <location> is the location of a checked-out\n";
	print "  CVSROOT copy.\n";
	exit(1);
}

my $dstdir = $ARGV[0];
chomp $dstdir;
while($dstdir =~ /\/$/)
{	chop $dstdir;	}

# Preserve our CWD
my $srcdir = $ENV{'PWD'};

# Hop over to our given install directory
chdir($dstdir) or die "Can't chdir to $dstdir";

# Now do some sanity testing
my @sdir = split "/", $dstdir;
my $end = $sdir[$#sdir];
die "I don't think '$dstdir' is a checked-out copy of the CVSROOT"
		unless ($end eq "CVSROOT");
die "No CVS/ dir, not a checked-out copy" unless -d "CVS";
die "No CVS/Repository file" unless -r "CVS/Repository";

open REPO, "CVS/Repository";
my $line = <REPO>;
close REPO;
chomp $line;
while($line =~ /\/$/)
{	chop $line;	}
@sdir = split "/", $line;
$end = $sdir[$#sdir];
die "This doesn't seem to be a checked-out CVSROOT"
		unless ($end eq "CVSROOT");
die "Can't find cvs(1) in path" unless
		(system("cvs >> /dev/null 2>&1") > 1);

# OK, enough damn sanity checking.  Let's do the install.
my @files = ('cvsmail.pm', 'cvsmail.cfg', 'cvsmail.pl', 'precommit.pl');
my $retval;
foreach my $file (@files)
{
	open IN, "$srcdir/$file" or die "Can't open $srcdir/$file";
	open OUT, ">$dstdir/$file" or die "Can't open $dstdir/$file";
	while(<IN>)
	{
		print OUT $_;
	}
	close OUT;
	close IN;
	chmod 0755, $file;
	$retval = system("cvs add $file");
	if($retval != 0)
	{
		print "Warning: 'cvs add' of $file didn't seem to work right.\n";
		print "You'll have to manually check it.  Carrying on...\n";
	}
}

# The main files are cvs add'd.  Now add the rest of the stuff.
open OUT, ">>checkoutlist" or die "Can't open checkoutlist";
print OUT "cvsmail.pm           Can't co cvsmail.pm\n";
print OUT "cvsmail.cfg          Can't co cvsmail.cfg\n";
print OUT "cvsmail.pl           Can't co cvsmail.pl\n";
print OUT "precommit.pl         Can't co precommit.pl\n";
close OUT;

open OUT, ">>commitinfo" or die "Can't open commitinfo";
print OUT "ALL                  \$CVSROOT/CVSROOT/precommit.pl\n";
close OUT;

open OUT, ">>loginfo" or die "Can't open loginfo";
print OUT "ALL      \$CVSROOT/CVSROOT/cvsmail.pl \%\{sVv}\n";
close OUT;


# Done.
print <<EOF


*** Install finished! ***

You should now edit 'cvsmail.cfg' to fit this repository (with any luck,
the \$MAILTO variable will be all you need to adjust, though a few others
may need a tweak depending on your system.

Once you're satisfied with that, run 'cvs commit' to commit it in and
activate it.  It should take effect on your next commit after that!
EOF
